/* -*- mode: Java; c-basic-offset: 2; indent-tabs-mode: nil -*-
 *
 * $Id$
 *
 * Copyright (c) 2010 ljnelson.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 * The original copy of this license is available at
 * http://www.opensource.org/license/mit-license.html.
 */
package ljnelson.caturgiator.web;

import java.io.IOException;

import javax.ejb.EJB;

import javax.inject.Inject;

import javax.servlet.ServletException;

import javax.servlet.http.*;

import javax.servlet.annotation.WebInitParam;
import javax.servlet.annotation.WebServlet;

import ljnelson.caturgiator.api.Caturgiator;

@WebServlet(urlPatterns = { "/*" }, 
            name = "CaturgiatorServlet", 
            description = "Caturgiator Servlet")
public class CaturgiatorServlet extends HttpServlet {

  @Inject
  private CaturgiatorSessionScopedObject thing;

  @Inject
  private Caturgiator caturgiator;

  @Override
  protected void doGet(final HttpServletRequest request, final HttpServletResponse response) throws IOException, ServletException {
    if (thing == null) {
      throw new ServletException("CDI failed");
    }
    if (caturgiator == null) {
      throw new ServletException("No caturgiator");
    }
    response.getWriter().println("Thing: " + thing.getMessage());
    thing.setMessage(new java.util.Date().toString());
    response.getWriter().flush();
  }

}